'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = runtimeSSRMiddle;

var _mobileDetect = require('mobile-detect');

var _mobileDetect2 = _interopRequireDefault(_mobileDetect);

var _render = require('./render');

var _render2 = _interopRequireDefault(_render);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function runtimeSSRMiddle({
  routes, renderFullPage, createApp, initialState, onRenderSuccess, timeout = 6000, verbose = true
}) {
  return (() => {
    var _ref = _asyncToGenerator(function* (req, res, next) {
      const isMobile = !!new _mobileDetect2.default(req.headers['user-agent']).mobile();
      const result = yield (0, _render2.default)({
        url: req.url,
        env: { platform: isMobile ? 'mobile' : 'pc' },
        routes,
        renderFullPage,
        createApp,
        initialState,
        onRenderSuccess,
        timeout,
        verbose
      });
      switch (result.code) {
        case 200:
          return res.end(result.html);
        case 302:
          return res.redirect(302, result.redirect);
        case 404:
          next();
          break;
        case 500:
          next(result.error);
          break;
        default:
          next();
          break;
      }
    });

    return function (_x, _x2, _x3) {
      return _ref.apply(this, arguments);
    };
  })();
}
module.exports = exports['default'];